
#include "xc.h"
#include <builtins.h>
#include <string.h>
#include "LCD_4bits_I2C_2025-02.h"

// rev 10/08/2023  1 seul jeu de car speciaux
// rev  05/07/2023   Rajout set2 et set3   jeux de caractere speciaux utilis!

#ifndef _XTAL_FREQ 
  #define _XTAL_FREQ 64000000 
#endif

void Erase_Line(int L)
{
    Addr=LCD_ADDR;
switch(L)
 {
 case 1:
  {
   LCD_Cmd(LCD_LINE1);   //LCD_putcmd(LCD_LINE1,1);   
    LCD_putsRom(Efface);      
   LCD_Cmd(LCD_LINE1); //LCD_putcmd(LCD_LINE1,1);            
   break;
  }
  case 2:
  {
   LCD_Cmd(LCD_LINE2); //LCD_putcmd(LCD_LINE2,1);   
   LCD_putsRom(Efface);     
   LCD_Cmd(LCD_LINE2);//LCD_putcmd(LCD_LINE2,1); 
    break;
  } 
  case 3:
  {
   LCD_Cmd(LCD_LINE3); //LCD_putcmd(LCD_LINE2,1);   
     LCD_putsRom(Efface);  
   LCD_Cmd(LCD_LINE3);//LCD_putcmd(LCD_LINE2,1); 
    break;
  } 

  case 4:
  {
   LCD_Cmd(LCD_LINE4); //LCD_putcmd(LCD_LINE2,1);   
     LCD_putsRom(Efface);     
   LCD_Cmd(LCD_LINE4);//LCD_putcmd(LCD_LINE2,1); 
    break;
  } 

  }
 __delay_ms(10);
}

 //  LCD 2x16 + PCF8753
 // PCA8574 I2C LCD Routine
 // LCD Data PCA8574: P0,P1,P2,P3     Poids faibles !
 // LCD Control: P7: Back Light not used fixé avec R pull up., P4=E-Enable, P5=not Used RW au Grnd , P6= RS


void LCD_putcmd(unsigned char d,unsigned char cmdtype)
{
  unsigned char lcddata;
  Addr=LCD_ADDR;
 // avec RS=0
    // Put the Upper 4 bits data  on P7..P4
  lcddata =  (d & 0xF0) | LCD_EN | LCD_BL ;
   I2C_PCF8574_Write(Addr,lcddata );
  __delay_us(8);
  // Write Enable Pulse E: Hi -> Lo
   lcddata =  (d & 0xF0)| LCD_BL  ;
   I2C_PCF8574_Write(Addr,lcddata);
  __delay_us(8);      // __delay 1us for 16 MHz Internal Clock
  // cmdtype = 0; One cycle write, cmdtype = 1; Two cycle writes
  if (cmdtype==1)
  {
    // Put the Lower 4 bits data   on P7 ..P4
    lcddata = ((d & 0x0F) <<4) | LCD_EN | LCD_BL ;
     I2C_PCF8574_Write(Addr,lcddata);
    __delay_us(8);    // __delay 2us for 16 MHz Internal Clock
    // Write Enable Pulse E: Hi -> Lo
     lcddata = ((d & 0x0F)<<4) | LCD_BL ;
     I2C_PCF8574_Write(Addr,lcddata);
    __delay_us(8);    // __delay 1us for 16 MHz Internal Clock
  }
}


void LCD_putch(unsigned char d)
{
  unsigned char lcddata;
   Addr=LCD_ADDR;
     // Put the Upper 4 bits data     on P0 ..P3
  // avec RS=1
  lcddata =( (d & 0xF0) >>4 )| LCD_RS;
  I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  __delay_us(8);      // __delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  lcddata = (  ( (d & 0xF0) >>4 ) |  LCD_RS ) & (~LCD_EN) ;
  I2C_PCF8574_Write(Addr,lcddata);
  __delay_us(8);      // __delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bit data
  lcddata = (d & 0x0F) | LCD_RS | LCD_EN;
  I2C_PCF8574_Write(Addr,lcddata);
  __delay_us(8);      // __delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  lcddata = ( (d & 0x0F) | LCD_RS ) & (~LCD_EN);
  I2C_PCF8574_Write(Addr,lcddata);
  __delay_us(8);      // __delay 1us for 16 MHz Internal Clock
}


void LCD_Cmd(unsigned char d)
{
  unsigned char lcdcmd;
    Addr=LCD_ADDR;
 // avec RS=0
    // Put the Upper 4 bits data  on P7..P4
    lcdcmd =   (d & 0xF0)  | LCD_EN | LCD_BL;
    I2C_PCF8574_Write(Addr,lcdcmd );
  __delay_us(8);
  // Write Enable Pulse E: Hi -> Lo
  // lcdcmd =  ( (d & 0xF0) >> 4  | LCD_RW  )  & (~ LCD_EN);
     lcdcmd =   (d & 0xF0) | LCD_BL ;
     I2C_PCF8574_Write(Addr,lcdcmd);
    __delay_us(20);      // __delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bits data   on P7....P4
     lcdcmd = ((d & 0x0F)<<4)| LCD_EN | LCD_BL;
     I2C_PCF8574_Write(Addr,lcdcmd);
      __delay_us(20);    // __delay 2us for 16 MHz Internal Clock
    // Write Enable Pulse E: Hi -> Lo
     lcdcmd = (d & 0x0F)<<4 | LCD_BL ;
     I2C_PCF8574_Write(Addr,lcdcmd);
      __delay_us(20);    // __delay 1us for 16 MHz Internal Clock
}


void LCD_Data(unsigned char d)
{
  static  unsigned char lcddata;
    Addr=LCD_ADDR;
   // Put the Upper 4 bits data     
  //on P3 ..P0 LCD2x16 et P7..p4 LCD4x20
  // avec RS=1
  lcddata=  ((d & 0xF0) )| LCD_RS | LCD_EN | LCD_BL;
  I2C_PCF8574_Write(Addr,lcddata);
    __delay_us(8);      // __delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
 // lcddata =  ( ( (d & 0xF0) >>4 ) |  LCD_RS | LCD_RW  )  & (~LCD_EN);
  lcddata =   (d & 0xF0)  | LCD_RS | LCD_BL ;
  I2C_PCF8574_Write(Addr,lcddata);
   __delay_us(8);      // __delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bit data
 // lcddata = (d & 0x0F) | LCD_RS | LCD_EN | LCD_RW;
  lcddata =  ( (d & 0x0F) <<4 ) | LCD_RS | LCD_EN | LCD_BL;
  I2C_PCF8574_Write(Addr,lcddata);
    __delay_us(8);      // __delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
   lcddata =  ( (d & 0x0F) <<4 ) | LCD_RS | LCD_BL ;
  I2C_PCF8574_Write(Addr,lcddata);
    __delay_us(8);     // __delay 1us for 16 MHz Internal Clock
}



void LCD_init(void)  // OK !
{
  
  // Wait for more than 15 ms after VCC rises to 4.5 V
  CPrint(" .1");
  LCD_putcmd(0x30,0);
  // Wait for more than 4.1 ms
  __delay_ms(5);
   PrintChar('2');
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  __delay_ms(1);
  // Send Command 0x30
     PrintChar('3');
  LCD_putcmd(0x30,0);
    __delay_ms(1);
  // Function set: Set interface to be 4 bits long (only 1 cycle write).
      PrintChar('4');
 LCD_putcmd(0x25,0); 
    __delay_ms(1);
  // Function set: DL=0;Interface is 4 bits, N=1; 2 Lines, F=0; 5x8 dots font)
       PrintChar('5');
  LCD_putcmd(0x28,1);
     __delay_ms(1);
  // Display Off: D=0; Display off, C=0; Cursor Off, B=0; Blinking Off
       PrintChar('6');
  LCD_putcmd(0x08,1);
    __delay_ms(1);
  // Display Clear
       PrintChar('7');
  LCD_putcmd(LCD_CLEAR,1);
    __delay_ms(25);
  // Entry Mode Set: I/D=1; Increament, S=0; No shift
       PrintChar('8');
  LCD_putcmd(0x06,1);
      __delay_ms(1);
  // Display On, Cursor Off
       PrintChar('9');
  LCD_putcmd(0x0C,1);
    __delay_ms(1);
        PrintChar('O');PrintChar('K');
}



void LCD_putsRom(const unsigned char *s1)
{  int i;
    i=0;
   while((*s1 != 0)&& (i<NbCarPL))
  {
    LCD_Data(*s1); //     LCD_putch(*s1);
    s1++;i++;
     __delay_us(25); // was __delay_ms(1);
  }
}

void LCD_puts( unsigned char *s)
{  int i;
   i=0;
  while((*(s+i) != 0) && (i<NbCarPL))
  {
    LCD_Data(*(s+i));  // LCD_putch(*(s+i));
    i++;
  }
}
  

void LCD_Write_CText(const unsigned char *txt)
{  static int i1;
   i1=0;
   while ((*txt) && (i1<NbCarPL))
   i1++;
   LCD_Data(*(txt++)); //LCD_putch(*(txt++));
   __delay_us(25); // was __delay_ms(1);
 }


void LCD_Chr_At(int Ligne,int col,unsigned char c1)
{
   Addr=LCD_ADDR;
  if(col>NbCarPL) col=NbCarPL;
  if (Ligne==1) LCD_Cmd(LCD_LINE1+col-1);  
  if (Ligne==2) LCD_Cmd(LCD_LINE2+col-1); 
  if (Ligne==3) LCD_Cmd(LCD_LINE3+col-1);  
  if (Ligne==4) LCD_Cmd(LCD_LINE4+col-1); 
   __delay_ms(25);
    LCD_Data(c1); //  LCD_putch(c1);
    __delay_ms(1);// was __delay_ms(25);
 }


void LCD_At(unsigned char Ligne,unsigned char col)
{
  Addr=LCD_ADDR;
  if(col>NbCarPL) col=NbCarPL-1;
  if (Ligne==1) LCD_Cmd(LCD_LINE1+col-1);  
  if (Ligne==2) LCD_Cmd(LCD_LINE2+col-1); 
  if (Ligne==3) LCD_Cmd(LCD_LINE3+col-1);  
  if (Ligne==4) LCD_Cmd(LCD_LINE4+col-1); 
   __delay_ms(10);// was __delay_ms(20);
}

void LCD_Write_Text_At(unsigned char Ligne,unsigned char Col,unsigned  char * t1)
{  LCD_At(Ligne,Col);
   LCD_puts(t1);
    __delay_ms(1);
}


void LCD_Write_CText_At(unsigned char Ligne,unsigned char col, const unsigned char * t1)
{ char Table1[21];  // Table1[17];// LCD2x16
 int k;
  k=strlen(t1);
  if (k<21)
  {
  //    strncpy(Table1,t1,k);
  strConstRamCpy(Table1,t1);
  *(Table1+20)=0;  //  *(Table1+17)=0;// LCD2x16
  if(col>=NbCarPL-k) col=1; 
 if (Ligne==1) LCD_Cmd(LCD_LINE1+col-1);  
  if (Ligne==2) LCD_Cmd(LCD_LINE2+col-1); 
  if (Ligne==3) LCD_Cmd(LCD_LINE3+col-1);  
  if (Ligne==4) LCD_Cmd(LCD_LINE4+col-1); 
   __delay_ms(1);// was __delay_ms(20);;
  LCD_puts(Table1);
  }
}


//   affiche les pixels de chaque jeux de caracteres sur le terminal UART
void LCD_Load_Custom_Chars(int Cause)
// 1 seul jeu utilis!
{ 
 unsigned int  i, j;
 unsigned int  k;
 // Set address counter pointing to CGRAM address 0.
 LCD_Cmd(0x40);
  __delay_ms(25); // was 250
 // Load custom lcd character data into CGRAM.
 // It can only hold a maximum of 8 custom characters.
 k=0;
 if ( Cause==1) 
 {
     CPrint(Special_Name1[k]);
     CRLF1();
 }    
 for(i = 0; i <64; i++)
 {
   if (Cause==1)
   {
      if ( (i>0) && (  ( i%8) ==0)  )
      {
      CPrint(Special_Name1[k]); 
      k++;
      CRLF1();
     }
   } 
   LCD_Data(LCD_Custom_Chars_Set1[i]);
   if (Cause==1) 
   {  Decompile_byte( LCD_Custom_Chars_Set1[i]);
      //   __delay_ms(10);
      CRLF1();
   }
  } // for i 
 // Set address counter pointing back to the DDRAM.
 LCD_Cmd(0x80);
  __delay_ms(10); // was 150
}

