
#include "xc.h"
#include <math.h>
#include <stdint.h>
#include <stdbool.h>
#include <stdio.h>
#include <ctype.h>
#include <limits.h>
#include <string.h>

#ifndef _XTAL_FREQ
#define _XTAL_FREQ 64000000 
#endif

#ifndef Byte
#define Byte  unsigned char
#endif
#ifndef Word
#define Word  uint16_t
#endif

//#define With_SQA_Analyser
//#define With_SMT1


#define With_Terminal   // YAT 
#define With_LCD         //4x20 I2C
#define With_NCO1
#define VERSION "2025-0227"
#define MCU " 18F27K42"
#define POWER_SUPPLY " 5V "
#define DIR " C:\\MPLABX_PrOJECTS"
#define COMPILO "XC8 V2.36 C99"
#define PACK "PIC18F-K_DFP 1.6.125"

#define CR 13
#define LF 10
#define TAB 9

#ifdef With_SQA_Analyser
#define SQA_Dir TRISAbits.TRISA3
#define SQA LATAbits.LA3
#endif

// avec mes leds tires au +Vcc
#define ON  0
#define OFF 1

#define LED_rouge   LATAbits.LA4 	//	LED_rge	Led Rouge : PRG (Programmation)	
#define SQA         LATAbits.LA3 
#define Buzzer     LATCbits.LC2 

#define UP   1
#define DOWN 0

#define Directory "C:\\MPLABX_Projects\\_18F27K42_INA226_I2C_LCD_UART_2025.X"
#define Project  " _18F27K42_I2C_LC_UART_2023"
#define Source   " main.c "
#define Annexe   " XC8 V2.36 C99  Pack: PIC18F-K_DFP 1.6.125"
#define Others   " LCD_4bits_I2C_2025-02.h,UART1_Functions.h ,LCD_chars_Speciaux_2025-02.h\r\n" // 92 chars
#define Inclusion " Dialogue_Operateur_PC_via_UART_2025-02.inc" 
#define Eeprom   " ... "
#define Hardware " Base 18F27K42 "
#define Config   " Internal Fosc 64MHz"

int PWM5_Freq[8]={ 0,32000,16000,8000,4000,2000,1000,500};

#define With_Test_Presence_Devices 

// was bad with :
  const  char Msg0[]=" PIC18F27K42 + Test INA226 R100 I2C sensor \r\n En Mode DC PWM 4Khz\r\n";
  const  char Msg1[]=" Directory :"Directory"\r\n";
  const  char Msg2[]=" Project : "Project"\r\n";
  const  char Msg3[]=" Source : "Source"_"VERSION"\r\n";
  const  char Msg4[]=" Config "Config"\r\n";
  
  const  char Msg5[]=" Test PWM5 10 bits->RC1pps Out-> MOSFET->Ampoule 12V 5w\r\n";
  const  char Msg6[]=" Aiguillage sortie via RC1PPS= 0x0D ";
 // const  char Msg5[]=" Autres : "Others"\r\n";
 // const  char Msg6[]=" Eeprom : "Eeprom"\r\n";
  const  char Msg7[]=" RB0 in=ALErt , RA4=led, RC2PPS NCO1 out=Buzzer,UART RC6=TX,RC7=RX\r\n";
  const  char Msg8[]=" Include: "Inclusion"\r\n";
  const  char Msg9[]=" LCD 4x20 cars sur bus I2C1 HW : RC3=SCL,RC4=SDA\r\n";
  const  char * Messages[]={Msg0,Msg1,Msg2,Msg3,Msg4,Msg5,Msg6,Msg7,Msg8,Msg9};
  const  char Blancs[]="  ";
  
#include "i2c1_master.h"
#include "i2c1_master_example.h"
#include "UART1_Functions.h"
#ifdef  With_LCD 
#include "LCD_4bits_I2C_2025-02.h"
#endif

#include "Define_Org.h"

const  float NCO1_Clock[5]={64000000.0,64000000.0,32000.0,500000.0,32000.0};
const char NCO1_CL4[] =" MFINTOSC/4 (32 kHz)";
const char NCO1_CL3[] ="  MFINTOSC (500 kHz)";
const char NCO1_CL2[] =" LFINTOSC" ;
const char NCO1_CL1[] =" HFINTOSC ";
const char NCO1_CL0[] =" FOSC";
const char * NCO1_Clock_Name[] ={ NCO1_CL0,NCO1_CL1,NCO1_CL2,NCO1_CL3, NCO1_CL4};


#define LCD_ADDR 0x27
#define INA226_ADDR 0x40  // sur 7 bits

  
//__EEPROM_DATA (0,'2','5','0','2','1','7',0);
//__asm ("ORG 0x310010");
//__asm ("DA 0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37");
//__asm ("DE : 'P','a','u','l','f','j','u',0); 
  
 
//-------------------------------------------

#define UART1_RX_BUFFER_SIZE 128 
  
// variables Globales usuelles 
unsigned int  i,j,k,l,m,n;
unsigned char  c1,c2,c3,cx,cc;

unsigned int Nb_Boucles=0;
volatile unsigned char Buffer1[UART1_RX_BUFFER_SIZE];
volatile unsigned int Index1,i1;
volatile unsigned char Flag_Buffer1=0;
unsigned char TEXTE [128];
unsigned char * txt;
volatile char Bavard=0;
bool Status_GIE_Bit;  

unsigned char * p0;
unsigned char * px;
unsigned char * p1;
unsigned char CRam1[80];
unsigned char Tampon[32];
unsigned int  Rep;

float F0,F1,F2,F3;

volatile uint16_t Count0, Count1 ;
volatile uint16_t Count_RB0=0;
volatile uint16_t Cpt0, Cpt1;    
volatile uint16_t Flag_Timer1=0;
volatile uint16_t Flag_Timer2=0;
volatile uint16_t Flag_Timer3=0;
volatile uint16_t Flag_Timer4=0;
volatile uint16_t Flag_Timer6=0;
volatile signed int  Cpt6=0;  // decompteur
volatile  signed int Cpt4=0;// decompteur
volatile unsigned  int Cpt2;  //compteur sans fin
unsigned int Duree_Appui=0;
unsigned int Duree_Boucle=0;
bool Status_GIE_Bit;

#ifdef With_SMT1
unsigned long SMT1_Measure;
unsigned  char *ST;
unsigned long  L1=0;
unsigned long  L2=0;
#endif

//   LCD 
volatile unsigned char Addr;
//volatile unsigned char Adresse_7bits;
unsigned char I2_Adresses_Devices[8];
//unsigned char tmp[10]={0,0,0,0,0,0,0,0,0,0}; // pour I2C write
char tmp[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // pour I2C write
int Etat;


#define     AVERAGE_1      0x0000 
#define     AVERAGE_4      0x0200
#define     AVERAGE_16     0x0400
 #define    AVERAGE_64     0x0600

 // Conversion time in microseconds
#define      CONV_TIME_140    0
#define      CONV_TIME_204    1
#define      CONV_TIME_332    2
#define      CONV_TIME_588    3
#define      CONV_TIME_1100   4
#define      CONV_TIME_2116   5
#define      CONV_TIME_4156   6
#define      CONV_TIME_8244   7

// INA226_measureMode;
#define    INA226_POWER_DOWN  0x00
#define    INA226_TRIGGERED   0x03
#define    INA226_CONTINUOUS  0x077

// INA226_ALERT_TYPE
#define      SHUNT_OVER     0x8000
#define      SHUNT_UNDER    0x4000
#define      BUS_OVER       0x2000
#define      BUS_UNDER      0x1000
#define      POWER_OVER     0x0800
#define      CURRENT_OVER   0xFFFE
#define      CURRENT_UNDER  0xFFFF


 #define INA226_CONF_REG        0x00 //Configuration Register
 #define INA226_SHUNT_REG        0x01 //Shunt Voltage Register
 #define INA226_BUS_REG          0x02 //Bus Voltage Register
 #define INA226_PWR_REG          0x03 //Power Register 
 #define INA226_CURRENT_REG      0x04 //Current flowing through Shunt
 #define INA226_CAL_REG          0x05 //Calibration Register 
 #define INA226_MASK_EN_REG      0x06 //Mask/Enable Register 
 #define INA226_ALERT_LIMIT_REG  0x07 //Alert Limit Register
 #define INA226_MAN_ID_REG       0xFE //Contains Unique Manbufacturer Identification Number
 #define INA226_ID_REG           0xFF //Contains unique ID

        /* parameters, flag bits */
 uint16_t INA226_RST        =0x8000; //Reset 
 uint16_t INA226_AFF        =0x0010; //Alert function flag
 uint16_t INA226_CVRF       =0x0008; //Conversion ready flag
 uint16_t INA226_OVF        =0x0004; //Overflow flags AFF
 uint16_t INA226_ALERT_POL  =0x0002; //Alert pin polarity - if set then active-high
        //Latch enable - if set then alert flag remains until mask/enable register is read
        //if not set then flag is cleared after next conversion within limits
 uint16_t INA226_LATCH_EN   =0x0001; 


//--- INA226-----
  int16_t mvA=0;   
  uint16_t mvU=0; // toujours positif
  float Power=0.0;
  int16_t mA=0;
  float Amps=0.00;
  float Volts=0.00;
  float Seuil_Alerte=0.0;
  
  uint8_t AFF_Flag=0;
  uint16_t ALERTE_STATUS=0;
  
 
  const float NCO1_Coeff= 4.194; // 2097152/500.000=  4.194
  char NCO1_Clock_Choix=0;  // 0  4

char *pC;
char *pI;
char PWS_Valeur=0 ;  // = 2 ^ PWS_Choix =>{1,2,4,8,16,32,64,128]};
char PWS_Choix;  // 0  7
unsigned long Increment;
int Choix_Freq_PWM=3;
int Consigne_Duty_PWM=0;
int Mode_Rampe=0;


unsigned int EAx;


volatile struct Anybits {   // 8 flags
       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  NCO_initialise:1;   // for NCO
       unsigned  Key_ON :1;          // detection appui BP
 }Drapeaux ;
 
 #ifdef With_NCO1 
void NCO1_Init (void);	

#endif

#ifdef With_LCD
void  Affiche_LCD_Repos(void);
#endif
 
void Interrupt_Init(void);
void Hardware_Init();
void Init_Timer2(void);
void Init_Timer4(void);

void Init_I2C (void);
void I2C_PCF8574_Write(unsigned char  Ad , unsigned char value);
void   INA226_Init_Config(void);

void BCD_To_Ascii(unsigned char cc,unsigned char * px);
unsigned char  Bcd2Dec( unsigned char v1);
unsigned char Dec2Bcd(unsigned char n);

void __delay_xSec(unsigned char N);

void Init_Timer2(void); // pour PWM5
void PWM5_Initialize(void);
void PWM5_LoadDutyValue(uint16_t dutyValue);

void  Interrupt_Init(void)
{
    bool state =0;
    INTCON0bits.IPEN=1;
    state = (unsigned char)  INTCON0bits.GIE;
    INTCON0bits.GIEH = 0; // dishigh priority interrupts
    INTCON0bits.GIEL = 0; // dis low priority interrupts
    INTCON0bits.IPEN = 1; // Enable interrupt priority
   //  __asm("BCF INTCON0,GIE");
   // GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    IPR2bits.I2C1RXIP=1;
    IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 0;
    IPR3bits.TMR0IP = 0;
    IPR4bits.TMR2IP = 0;
    IPR7bits.TMR4IP = 0;
    IPR9bits.TMR6IP = 0;
    IPR0bits.IOCIP =  0;
     INTCON0bits.GIEL = 1; // Enable low priority interrupts
    INTCON0bits.GIEH = 1; // Enable high priority interrupts
    INTCON0bits.GIE= state;
}

void __interrupt(irq(IRQ_TMR4),low_priority)TMR4_ISR(void)
{  
    //U1TXB='%';
    Flag_Timer4=1;
    NCO1CONbits.EN=0; // stop buzzer
    LED_rouge=1; // eteinte
    T4CONbits.TMR4ON=0;
    PIE7bits.TMR4IE=0;
    PIR7bits.TMR4IF=0;
}

void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
{   
    uint8_t kb;
     if( (IOCBF & 0x01) ==1)
     {
     //INT0IF: External Interrupt 0 Interrupt Flag bit
     U1TXB='*';
     PrintChar('A'); PrintChar('L');   CRLF1();
     Count_RB0++;
     NCO1CONbits.EN = 1; // enable buzzer
     Init_Timer4();
     }
    PIR0bits.IOCIF=0;
    IOCBF=0;
    kb=PORTB;
    INT0IF=0;   
}

void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  //if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  if ( (U1RXIF==1) && (U1RXIE ==1) )
  {   
      c1 = U1RXB;
   //   U1TXB='*'; // echo
     if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
    // PIE3bits.U1RXIE =0;
     U1RXIE = 0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
}

// Conversion du code BCD en chiffre decimal
 unsigned char  Bcd2Dec( unsigned char  val)
{
 return ( (val>>4)*10 + (val%16) );
}

 void BCD_To_Ascii( unsigned char  cc, unsigned char * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }

unsigned char Dec2Bcd(uint8_t n)
{
 return (n / 10 * 16 +  n % 10);
}

void __delay_xSec(unsigned char N)
{
static int i2;  
for (i2=0;i2<N;i2++)  __delay_ms(1000);
}

#ifdef  With_LCD 
void I2C_PCF8574_Write(unsigned char Adrp,unsigned char value)
{ 
 tmp[0]=value;
 tmp[1]=0;
 I2C1_WriteNBytes(Adrp, tmp, 1);   
  __delay_us(50);
} 
#endif

void Init_Timer4(void)  // 1Sec ( avec 500Khz!
{ 
  T4CON    = 0x00;
 // choix clock   5=500Khz ,  1= FOSC/4  ,0=FOSC
   T4CLK=0x05;
  //  T4CLK=0x01;
 //  T4CONbits.CKPS2=1;//  7=> 1/128     4 => div 1/16 
 //   T4CONbits.CKPS1=1;
 //    T4CONbits.CKPS0=1;
  T4CONbits.CKPS=7;
  //bit 3-0 OUTPS[3:0]: Timerx Output Postscaler Select bits
  //1111 = 1:16 Postscaler     0000 = 1:1 Postscaler
  T4CONbits.OUTPS=15;  // div 1/(15+1)= 1/16
  T4PR=244;  // =2*128*16*(244+1)= 1 003 520  S => 1sec 
  T4TMR=0;
  T4RST=0x00; 
  Cpt4=0;
  Flag_Timer4=0;
  Drapeaux.Tmr4_Elapsed=0;
  PIE7bits.TMR4IE=1;
  PIR7bits.TMR4IF=0;
  T4CONbits.TMR4ON=1; 
}


void Init_Timer2()
{
  // PWM5 500Hz avec   CKPS=7 1/128 
  // PWM5 1000 avec   CKPS=6 1/64
  // PWM5 2000 avec   CKPS=5 1/32 
  // PWM5 4000 avec   CKPS=4 1/16 
    
  T2CON    = 0x00;
   T2CLK  =0x01;     //clock  5=500Khz   1= FOSC/4    2=FOSC
  // prescaler
 // T2CONbits.CKPS2=1;//CKPS=4 ->4Khz    2-> 16Khz   3->8Khz  5 => 1/32 ->2Khz  7 => 128 ->500Hz
 // T2CONbits.CKPS1=0;
 // T2CONbits.CKPS0=0;
  T2CONbits.CKPS= Choix_Freq_PWM=3;
  T2CONbits.OUTPS=15;  // => div 1/16 NOT USED
  T2PR=250;
 // REGISTER 22-2: TxRST: TIMER2 EXTERNAL RESET SIGNAL SELECTION REGISTER p337
  T2RST=0x08;   // PWM5 out 
  Flag_Timer2=0;
  PIE4bits.TMR2IE=0;
  PIR4bits.TMR2IF=0;
  T2CONbits.T2ON =1;
}


void PWM5_Initialize(void)
 {
    PWM5CON = 0x80;   
    PWM5DCH = 0x00;   
    PWM5DCL = 0x00;   
    CCPTMRS1bits.P5TSEL = 1;// Select timer 2
 }

 void PWM5_LoadDutyValue(uint16_t dutyValue)
 {
     // Write 8 MSBs of PWM duty cycle in PWMDCH
     PWM5DCH = (dutyValue & 0x03FC)>>2;
     // Write 2 LSBs of PWM duty cycle in PWMDCL
     PWM5DCL = (dutyValue & 0x0003)<<6;
 }



void Hardware_Init(void)
{
    LATA = 0x00;
    LATB = 0xFF;
    LATC = 0x04;
    
    TRISA = 0b11101111;  
    TRISB = 0xFF;
    TRISC = 0b10100001;  
  
    ANSELC = 0x00;
    ANSELB = 0x00;
    ANSELA = 0x00;

    WPUE = 0x00;
    WPUB = 0xFF;
    WPUA = 0xFC;
    WPUC = 0xC0;  // RX TX UART
    
    RA0PPS=0;
    RA1PPS=0;
    RA2PPS=0;
    RA3PPS=0;
    RA4PPS=0;

   // RxyI2C registers
   // RB1I2C = 0x00;
   // RB2I2C = 0x00;
   
    RB0PPS=0;
    RB1PPS=0;
    RB2PPS=0;
    RB3PPS=0;
    RB4PPS=0;
    RB5PPS=0;
    RB6PPS=0;
    RB7PPS=0;
   // RC3I2C = 0x00;
   // RC4I2C = 0x00;

   // ODx registers
    ODCONA = 0x07;  //  0x07 => open drain sur RA0,RA1,RA2  OWS sensor
    ODCONB = 0x00;
    ODCONC = 0x18;  // I2C 
   
  //  SLRCONx registers
    SLRCONA = 0xFF;
    SLRCONB = 0xFF; //0xFF;
    SLRCONC = 0xFF;

   // INLVLx registers
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;
    
    IOCAF=0;
    IOCAN=0;
    IOCAP=0;

    IOCBF=0;
    IOCBN=0;
    IOCBP=0;
    
    IOCCF=0;
    IOCCN=0;
    IOCCP=0;
   
    RC1PPS = 0x0D;   //PWM5:PWM5;
    RC2PPS = 0x26;   //RC2->NCO1:NCO1;  //for buzzer     
	// I2C1
    RC3PPS = 0x21;      //RC3->I2C1:SCL1;    
    RC4PPS = 0x22;      //RC4->I2C1:SDA1; 
    RC5PPS=0; 
    // UART1
    RC6PPS = 0x13;      //RC6->UART1:TX1;    
    U1RXPPS = 0x17;     //RC7->UART1:RX1;    
    I2C1SCLPPS = 0x13;  //RC3->I2C1:SCL1;  
    I2C1SDAPPS = 0x14;  //RC4->I2C1:SDA1;     
}

// -------------  I2C --------------------------------

void Init_I2C (void)
{   
    I2C1CLK    = 0x03;      // I2C1 Clock Selection Register, MFINTOSC 500kHz ?? 100kHz ??  // doc p. 581
  // 2-04-2023  probleme maxi pCF SLC =100KHz
  //  I2C1CLK    = 0x06;    ///0110	 TMR2 post scaled output	42Khz theorique
  // SQA mesure  18.00+11.76=29.76S -> 33.6Khz ?? why ?
    I2C1CON0   = 0x04;      // I2C1 Control Register 0, Master mode, 7-bit Address  // doc p.577
    I2C1CON1   = 0x80;      // I2C1 Control Register 1, Acknowledge value transmitted after received data 
                            //(when I2CCNT=0) : 1 = NACK     (Not ACKnowledge)  // doc p.579
    I2C1CON2   = 0x00;      // I2C1 Control Register 2, envoi Start non auto, SDAHT 300ns hold time, BFRET 8 i2c clock pulses  // doc p.580
    I2C1CNT = 0;
 //   I2C1CON2bits.FME=1;
    I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
     // I2C1ADB1   = 0x3C;      //0x3C adresse bus I2C mini oled SSD1306
    I2C1ADB1   = Addr;   // LCD 2x16 ou 2x20 avec PCF8754
    I2C1PIRbits.PCIF = 0;  // clear STOP bit flag
  //  I2C1CON2bits.ABD=1;   
    I2C1CON0bits.EN=0;   // i2c1 OFF   
}

 bool I2C1_DevicePresent(uint8_t Address)
{
I2C1PIRbits.PCIF = 0;                // clear STOP bit flag
I2C1ADB1 = Address;                  // load slave Addr and R/W
I2C1CNT = 0;
I2C1CON0bits.S = 1;                  // send START + Addr
while (I2C1PIRbits.PCIF == 0);       // wait for STOP
return !I2C1CON1bits.ACKSTAT;
}

void Test_Presence_I2C_devices()
{
 int i,j;
 txt=&TEXTE[0]; 
 *(txt)=0;
 //I2C1CON2 = 0x00;  // <- OK
I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
I2C1CON0bits.EN = 1;
for (i=2; i<252; i=i+2)
{
if (I2C1_DevicePresent(i))
{
k=i>>1;
sprintf(txt," @ decimal #%4u  soit @Device 7bits = 0X%02X ",i,k);
//Print(txt);
switch (k)
{
case 0x20:// de base + 7 autres
case 0x21:
case 0x22:
case 0x23:
    //...etc 
case 0x27:
   strcat(txt," PCF8754 for LCD 2x16cars"); 
   break;
case 0x28:
case 0x29:
case 0x2A:
// case etc ..
strConstRamCpy(CRam1,"PCF8574 8bits IO" );  
  j=strlen(txt);
  strcpy(txt+j,CRam1);
  break;
case 0x37:
   strcat(txt,"LCD 2119 2x16cars"); // de base + 7 autres
   break;
case 0x38:
case 0x39:
case 0x3A:
case 0x3B:
  // case etc ..
  strcat(txt,"PCF8574A 8bits I/O"); // de base + 7 autres
  break;
case 0x3C:
strcat(txt,"OLED SSD1306");
break;
case 0x40:
   strcat(txt,"INA226 Current sensor");
   break;
case 0x57:
strcat(txt,"EEPROM 512bytes");
break;
case 0x68:
strcat(txt,"RTC DS3231");
break;
case 0xA0:
strcat(txt,"Eeprom 24LCxxx 256k ou 512K");
break;
default:
strcat(txt,"non connu !");
break;
}
Print(txt);CRLF1();
}
}
I2C1CON0bits.EN = 0;
//I2C1CON2 = 0x18;
I2C1CON2bits.ABD=1;
CRLF1();
I2C1CON0bits.EN = 1;
}

#ifdef  With_LCD
void  Affiche_LCD_Repos()
 {  // rev 16-07-06-2023
     Addr=LCD_ADDR; 
    LCD_Cmd(LCD_HOME); __delay_ms(100);
    LCD_Write_CText_At(1,1 ,"INA226 Tests 20250227");
    CRam1[0]=0;
    sprintf(CRam1,          " Nb boucles=%5d  ",Nb_Boucles);
    LCD_Write_Text_At(2,1,CRam1); 
      CRam1[0]=0;
    sprintf(CRam1," U=% 5d  A=% 5d",mvU,mvA);
    LCD_Write_Text_At(3,1,CRam1); 
      CRam1[0]=0;
    sprintf(CRam1,  " %3.2f V  %3.3f A    ",Volts,Amps);
    if (AFF_Flag==1) 
    {
        *(CRam1+18)='A'; 
        *(CRam1+19)='L';
    }
    LCD_Write_Text_At(4,1,CRam1);   
  }
#endif

void print_hex_32( uint32_t value )
{
   signed char        nibble;
   char   msg[2];
   char   c;
   msg[1] = '\0';
   for( nibble = 7; nibble >= 0; nibble-- )
   {
      c = value >> (nibble * 4);
      c = c & 0x0F;
      if( c < 10 )
      {
         msg[0] = 0x30 + c;
	    }
      else
      {
        msg[0] = 'A' + c - 10;
      } 
     Print( msg );
   }
   return;
}


void INA226_Init_Config(void)
{   
    CPrint(" Config  INA226_CONF_REG,0x43FF (was 0x4127 )\r\n");
    p1=&tmp[0];
    //  Addr=0x40; // INA226_ADDR   0x40 8 bits; 
    // configuration RST  AVGX VBUSCTX VSHCTX   MODEx   // 16-bits
    // AVG2 AVG1 AVG0  bit 9  11
    // 0 => 1    1 => 4   2-> 8  3-> 16   4 -> 128 ...... 7 -> 1024
    //Reset 1  dumy 000  NbAverage 001= 4 
     
    // conversion Time Vbus 100=1,1mS  conversion Time SHuntV 100=1,1mS
    // mode 111 Shunt & bus continuous
    // 0b 0 000 001     Vbus 011   Vsht 111    mode 111; 
    // 0b 0100  0100 0011 1111; 
    //  INA226_Write_16bits_Register(INA226_CONF_REG,0x4127);
      tmp[0]=INA226_CONF_REG;
      tmp[1]=0x43;  // 128 average 
      tmp[2]=0xFF;
      Addr=INA226_ADDR;
     // I2C1CON2bits.ABD=1;
      cx=3;
      I2C1_WriteNBytes(Addr, p1, cx); 
      CPrint(" Calibration register 05h <- 0x0034 \r\n");
      // 0x00D1B
      tmp[0]=INA226_CAL_REG;
      tmp[1]=0x00;
      tmp[2]=0x34;
      Addr=INA226_ADDR;
      p1=&tmp[0];
      cx=3;
      I2C1_WriteNBytes(Addr, p1,cx);
     //  Mask / Enale Register   
     //  SOL/SUL shunt voltage over/Under Limit Alert
     //  BOL /BUL  Bus Voltage Over/Under Limit Alert
     //  POL :Power Over limit Alert           
     //  CNVR Convertion Readdy Alert   
      // 0b 1 0 0 0 0 0 0 0
      // shunt Over alert
      // // 0b 0 0 0 AFF CVRF OVF APOL LEN 
      // AFF Alarm Fonction Flag aune limite a t franchie !
      // CVRF conversion Ready Flag mesure OK   OVF : Overflow Flag  debordement d'un registre
      // APOL= Alert polarity=active high with APOL=0   LEN=1 =Alarme Latche enable
        CPrint(" Mask/Alert  MASK_EN_REG register 06h <- 0x8001\r\n");
        // 0x00D1B
        tmp[0]=INA226_MASK_EN_REG;
        tmp[1]=0x80;
        tmp[2]=0x00;  // pas de lacht EN=0
        Addr=INA226_ADDR;
        p1=&tmp[0];
        cx=3;
        I2C1_WriteNBytes(Addr, p1, cx);
           
         CPrint(" Alert MASK_EN_REG register 07h <- 10.000 pour 250mA\r\n");
        // 0x4E20 pour 20.000  500mA     avec 2 lampe 5W 12V en //
         //0x2710 pour 10000 250mA       1 seule lampe 5W 12V 
         // 0x3A98 pour 16000 375mA
        tmp[0]=INA226_ALERT_LIMIT_REG;
        tmp[1]=0x27;
        tmp[2]=0x10;
        Addr=INA226_ADDR;
        p1=&tmp[0];
        cx=3;
        I2C1_WriteNBytes(Addr, p1, cx);
            
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_CURRENT_REG, p1,3);
        k=(tmp[0]<<8) + tmp[1];
         sprintf(CRam1," Mesure de courant % 5d mA \r\n",k);
        Print(CRam1);
     
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_ALERT_LIMIT_REG, p1,3);
        k=(tmp[0]<<8) + tmp[1];
        Seuil_Alerte= 0.8192 * (float)k / 32768;
        sprintf(CRam1," Seuil d'alerte %3.3f Amperes\r\n",Seuil_Alerte);
        Print(CRam1);
      
        
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
         tmp[2]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_MAN_ID_REG, p1,3);  // 2260
        k=(tmp[0]<<8) + tmp[1];
        sprintf(CRam1," INA Manufactuer  0x%04X\r\n",k);
        Print(CRam1);
        
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
         tmp[2]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_ID_REG, p1,3);  // 2260
        k=(tmp[0]<<8) + tmp[1];
        sprintf(CRam1," INA Identifiant 0x%04X\r\n",k);
        Print(CRam1);
   
        CPrint(" Fin de parametrage INA226... OK\r\n\r\n");
  }


void NCO1_Init (void)			
{	  
    PIE4bits.NCO1IE =0;
    PIR4bits.NCO1IF=0;
    TRISCbits.TRISC2=0; 
    RC2PPS = 0x26;   //RC2->NCO1:NCO1;
    NCO1CONbits.EN=0;
    // EN disabled; POL active_hi; PFM FDC_mode Fixed Duty Cycle =divide by 2; 			
    NCO1CONbits.EN = 0;			
   	
    NCO1CON = 0x00;			
    NCO1CLK =  3;  //  0=FOSC  1=HFINTOSC  3=500Khz			
    NCO1ACCU = 0x00;			
    NCO1ACCH = 0x00;			
    NCO1ACCL = 0x00;				
   //Increment=4195L;  //1000 Hz
    Increment=1845L; //440Hz	
   // Increment=838; //200Hz
    pI=(char *)&Increment;					
     NCO1INCU=  *(pI+2);			
     NCO1INCH=  *(pI+1);			
     NCO1INCL=  *(pI+0);			
     NCO1CONbits.EN = 1; // Enable the NCO module	
     	
}	

int Lecture_INA_mA()
{ 
     Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];  
    I2C1_ReadDataBlock(Addr,INA226_CURRENT_REG,p1,3);
    mA=(tmp[0]<<8) + tmp[1];
    return(mA);
}

void Rampe(char sens)
{ int i;
   switch (sens)
   {
      case 0: 
          for (i=1023;i>1;i--) 
           {
             PWM5_LoadDutyValue(i);
             if (i % 32==0) 
             {
             CRam1[0]=0;
             sprintf(CRam1,"% 3d  En cours :% 5d mA\r\n",i/10,Lecture_INA_mA());
             Print(CRam1);
             }
             __delay_ms(5);
           } 
           break; 
      case 1: 

           for (i=0;i<1024;i++)  
           {
             PWM5_LoadDutyValue(i);
             if (i % 32 ==0) 
             {
             CRam1[0]=0;
             sprintf(CRam1,"% 3d  % 5d mA\r\n",i/10,Lecture_INA_mA());
             Print(CRam1);
             }         
           __delay_ms(5);
           }
           break; 
      default:
      PWM5_LoadDutyValue(0);
    }
     CRLF1();    
}


void Mesures_INA226(void)
{

    Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];
    I2C1_ReadDataBlock(Addr,INA226_BUS_REG, p1,3);
    mvU=(tmp[0]<<8) + tmp[1];
         
    Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];  
    I2C1_ReadDataBlock(Addr,INA226_SHUNT_REG,p1,3);
    mvA=(tmp[0]<<8) + tmp[1];
    
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_ALERT_LIMIT_REG, p1,3);
        k=(tmp[0]<<8) + tmp[1];
        Seuil_Alerte= 0.8192 * (float)k / 32768;
   //     sprintf(CRam1," Seuil d'alerte %3.3f Amperes\r\n",Seuil_Alerte);
   //     Print(CRam1);
 
    Addr=INA226_ADDR; 
    tmp[0]=0; tmp[1]=0;
    p1=&tmp[0]; // pointeur sur debut de table
    I2C1_ReadDataBlock(Addr,INA226_MASK_EN_REG,p1,2);
    ALERTE_STATUS= (tmp[0]<<8) + tmp[1];
    AFF_Flag=(ALERTE_STATUS & 0x00F0)>>4;
    
     if(AFF_Flag==1)   LED_rouge=0;  // allume led
    
      Addr= INA226_ADDR;
      tmp[0]=0;
      tmp[1]=0;
      p1=&tmp[0];
      I2C1_ReadDataBlock(Addr,INA226_CURRENT_REG, p1,3);
      mA=(tmp[0]<<8) + tmp[1];
     //   sprintf(CRam1," Mesure de courant % 5d mA \r\n",mA);
     //   Print(CRam1);
             
    Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];
    I2C1_ReadDataBlock(Addr,INA226_PWR_REG, p1,3);
    k=(tmp[0]<<8) + tmp[1];
    Power= (float)k / 2500.0;

}

void Affiche_datas_sur_Terminal(void)
{
    CRLF1();
    txt=&TEXTE[0];
    sprintf(txt,"%5d AFF=%d ", Nb_Boucles ,AFF_Flag );
    CRam1[0]=0;
    sprintf(CRam1," mvA=% 5d mvU=% 5d ",mvA,mvU);
    strcat(txt,CRam1);
    sprintf(CRam1," I=%5d mA ",mA);
    strcat(txt,CRam1);
    //Print(CRam1);
    Volts = mvU * 1.26 / 1000;
    Amps = mvA * 2.5/100000.0;
    sprintf(CRam1,"  %2.3f V  %2.3f A ",Volts,Amps);
    strcat(txt,CRam1);
   // Print(CRam1);
    sprintf(CRam1," %3.3f W  Seuil=%3.3f A",Power,Seuil_Alerte);
    strcat(txt,CRam1);
    Print(txt); 
}


void main(void)
{
    OSCCON1 = 0x60;
    OSCCON3 = 0x00;
    OSCEN = 0x00;
    OSCFRQ = 0x08;  // 64Mhz
    OSCTUNE = 0x00;
     __delay_ms(100);
   
    // NCO1MD DDS(NCO1) enabled; TMR0MD TMR0 enabled; TMR1MD TMR1 enabled; TMR4MD TMR4 enabled; TMR5MD TMR5 enabled; TMR2MD TMR2 enabled; TMR3MD TMR3 enabled; TMR6MD TMR6 enabled; 
    PMD2 = 0x00;  
    // CCP2MD CCP2 enabled; CCP1MD CCP1 enabled; CCP4MD CCP4 enabled; CCP3MD CCP3 enabled; PWM6MD PWM6 enabled; PWM5MD PWM5 enabled; PWM8MD PWM8 enabled; PWM7MD PWM7 enabled; 
    PMD3=0;

    Hardware_Init();
    
    GIE=0;  
    IOCIE=0;
    IOCAP=0;
    IOCAN=0;
    IOCAF=0;
    IOCCP=0;
    IOCCN=0;
    IOCCF=0;
    IOCBP=0;
    IOCBN=0;
    IOCEN=1;
   
    IOCBP   = 0x00;     // rising edge off
    IOCBN   = 0x01;  // falling edge RB0
    IOCBF   = 0;
    INT0EDG = 0;        // falling edge int0 B0
    PIE0bits.IOCIE=0;   // invalide toutes interrup IOC
    PIE1bits.INT0IE=1;
    PIR0bits.IOCIF=0;
    PIR1bits.INT0IF=0;

    for (i=0;i<sizeof(TEXTE);i++) TEXTE[i]=0;
    for (i=0;i<sizeof(Buffer1);i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    txt=&TEXTE[0]; 
          
    UART1_Init();
    __delay_ms(100);
    CRLF1();    CRLF1();     
    CPrint(" Presentation :");  
    CRLF1();     
    for (i=0;i<9;i++)   
    {
     CPrint(Messages[i]);   //<--- BAD des le 1er message
     __asm("btg LATA,4");
     __delay_ms(100);
    }
    CRLF1();
    sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d \r\n", __DATE__, __TIME__,__XC8_VERSION);
    Print(txt);
    CRLF1();

#ifdef With_NCO1  
    CPrint(" Init NCO1  1000Hz\r\n");  
    NCO1_Init ();	// 1000 Hz par defaut
    CPrint(" Test Buzzer sur sortie RC2 \r\n");  
    __delay_ms(100);
    NCO1CONbits.EN = 0;
   // TRISCbits.TRISC2=1; // passe en entree => stop buzzer
    __delay_ms(100);
   // TRISCbits.TRISC2=0; 
    NCO1CONbits.EN = 1;
    __delay_ms(200);
    NCO1CONbits.EN = 0;
  //  TRISCbits.TRISC2=1; 
 
 #endif
    CRLF1();
    CPrint(" Init_I2C()  100Khz;\r\n");
    Init_I2C(); //SCLK=  500Khz / 5 = 100Khz
    CPrint(" Test presence devices sur Bus I2C1\r\n");
    Test_Presence_I2C_devices();
    CRLF1();
  #ifdef  With_LCD  
    Addr=LCD_ADDR; 
    CPrint(" ATTENTION : Adresse I2C  LCD 4x20 definie dans :\r\n");
    CPrint(" LCD_4bits_I2C_2023-0810.h\r\n");
    CPrint(" via ligne #define LCD_ADDR 0xxx \r\n");
    CPrint(" 0x27 avec Proto Base 18F27K42\r\n"); 
    CRLF1();		
    NbCarPL=20; 
    Addr=LCD_ADDR;
    sprintf(CRam1," adresse LCD= %d soit 0X%02X \r\n",Addr,Addr);
    Print(CRam1);
    CPrint(" \r\nSequence d'Init LCD 4x20 via I2C1 PCF8574\r\n");
    LCD_init(); 
    CRLF1();
    LCD_Cmd(LCD_CLEAR);// 0x01
    __delay_ms(100);
    LCD_Cmd(LCD_HOME); //  0x02
    __delay_ms(100);
    CPrint(" Affichage sur LCD 4x20 \r\n");
    // gabarit   12345678901234567890
    LCD_putsRom("ABCDEFGHIJKLMNOPQRST");
    Erase_Line(2); 
    LCD_putsRom("12345678901234567890");
    Erase_Line(3); 
    LCD_putsRom(" Version Programme  ");
    Erase_Line(4); 
    LCD_putsRom(VERSION" 18F27K42");
    __delay_xSec(2);
  
    i=0;
    CPrint(" Chargement caracteres Speciaux set #1 en CGRAM\r\n");
    LCD_Cmd(LCD_CLEAR);__delay_ms(10); 
    Erase_Line(1);
    LCD_putsRom("Caracteres Speciaux2");
    Erase_Line(2);__delay_ms(10);
    LCD_Load_Custom_Chars(0);  // 0=mode silence 1=bavard
    /*
     for (i=0;i<8;i++) 
    {
        CPrint(Special_Name1[i]); CRLF1();
        LCD_Chr_At(2,i+1,i);  
     }
    __delay_xSec(4);
    */ 
       
#ifdef Test_all_char_LCD
 #include "Test_all_char_LCD.inc"
#endif  

#endif
   
    
    CPrint("\r\n Init_Timer2() (associ  PWM5)\r\n");  
    Init_Timer2(); //li  PMW5
    sprintf(CRam1," Init PWM5 10 bits (sur RC1)  Freq= %5d Hz \r\n", PWM5_Freq[Choix_Freq_PWM]);
    Print(CRam1);
    PWM5_Initialize();
    Consigne_Duty_PWM=150; //15%
    CPrint(" Mode Rampe=0\r\n");
    PWM5_LoadDutyValue(Consigne_Duty_PWM);
    sprintf(CRam1," PWM5 Duty = %4d %c \r\n",Consigne_Duty_PWM/10,'%');
    Print(CRam1);
    CRLF1();
    


    __delay_ms(1000);   
 
    CRLF1();  
    mvA=0;
    mvU=0;
    CPrint(" INA226_Init_Config \r\n");
    
    INA226_Init_Config();
      
    CPrint(" Boucle principale  programme \r\n");
    CPrint(" Alarme via interruption : sortie ALERTE INA226 -> RB0 input \r\n");
     
  //=============================================
  //         Boucle Principale 
  //=============================================      

    Interrupt_Init();
    
    PIR1bits.INT0IF =0;
    TMR4IF=0;
    PIE1bits.INT0IE=1;
    GIE =1;
    
    CPrint(" TMR4 initialise (1sec)\r\n");  
    Init_Timer4(); // 1sec mais non demarr
    Flag_Timer4=0;
    CRLF1();
   // do
   // {}
   // while (Flag_Timer4==0);
  // CRLF1();
  //  CRLF1();
   do
   {  
    RAZ_UART1_Buffer1(); // et arme interrupt UART RX   
    Mesures_INA226();
   // Affiche_datas_sur_Terminal();
   //  CRLF1();
   
    #ifdef  With_LCD
    Addr=LCD_ADDR; 
    Affiche_LCD_Repos();
    #endif

    Mesures_INA226();
    Affiche_datas_sur_Terminal();
 //   CRLF1();
    if( Mode_Rampe==1)
    {   
        CPrint("\r\n Rampe  UP 0  1024 ,mais check sur interval de 32 pas \r\n");
        Rampe(UP); 
        //  Mesures_INA226();
        //  Affiche_datas_sur_Terminal();
        CPrint("\r\n  Rampe DOWN   1024  0 mais check sur interval de 32 pas\r\n");
        Rampe(DOWN);
        //   Mesures_INA226();
        //   Affiche_datas_sur_Terminal();
        LED_rouge=1; // eteinte
     }
     else
     {
     PWM5_LoadDutyValue(Consigne_Duty_PWM);  
     __delay_ms(1000);
     }
     // delay de 1500mS  inclus ci dessous !
    #include "Dialogue_INA226_via_UART_2025-0227.inc"
     Nb_Boucles ++; 
   }  
   while (1);  
}


/*
 Presentation :
 PIC18F27K42 + Test INA226 R100 I2C sensor 
 En Mode DC PWM 4Khz
 Directory :C:\MPLABX_Projects\_18F27K42_INA226_I2C_LCD_UART_2025.X
 Project :  _18F27K42_I2C_LC_UART_2023
 Source :  main.c _2025-0227
 Config  Internal Fosc 64MHz
 Test PWM5 10 bits->RC1pps Out-> MOSFET->Ampoule 12V 5w
 Aiguillage sortie via RC1PPS= 0x0D  RB0 in=ALErt , RA4=led, RC2PPS NCO1 out=Buzzer,UART RC6=TX,RC7=RX
 Include:  Dialogue_Operateur_PC_via_UART_2025-02.inc

 Compile le Feb 27 2025 a 16:17:44 UTC
 avec version XC8 :  2360 

 Init NCO1  1000Hz
 Test Buzzer sur sortie RC2 

 Init_I2C()  100Khz;
 Test presence devices sur Bus I2C1
 @ decimal #  78  soit @Device 7bits = 0X27  PCF8754 for LCD 2x16cars
 @ decimal # 128  soit @Device 7bits = 0X40 INA226 Current sensor


 ATTENTION : Adresse I2C  LCD 4x20 definie dans :
 LCD_4bits_I2C_2023-0810.h
 via ligne #define LCD_ADDR 0xxx 
 0x27 avec Proto Base 18F27K42

 adresse LCD= 39 soit 0X27 
 
Sequence d'Init LCD 4x20 via I2C1 PCF8574
 .123456789OK
 Affichage sur LCD 4x20 
 Chargement caracteres Speciaux set #1 en CGRAM

 Init_Timer2() (associ  PWM5)
 Init PWM5 10 bits (sur RC1)  Freq=  8000 Hz 
 Mode Rampe=0
 PWM5 Duty =   15 % 


 INA226_Init_Config 
 Config  INA226_CONF_REG,0x43FF (was 0x4127 )
 Calibration register 05h <- 0x0034 
 Mask/Alert  MASK_EN_REG register 06h <- 0x8001
 Alert MASK_EN_REG register 07h <- 10.000 pour 250mA
 Mesure de courant     9 mA 
 Seuil d'alerte 0.250 Amperes
 INA Manufactuer  0x5449
 INA Identifiant 0x2260
 Fin de parametrage INA226... OK

 Boucle principale  programme 
 Alarme via interruption : sortie ALERTE INA226 -> RB0 input 
 TMR4 initialise (1sec)

moteur  l'arret!
   0 AFF=0  mvA=  393 mvU=12525  I=   10 mA   15.781 V  0.010 A  0.003 W  Seuil=0.250 A
    1 AFF=0  mvA=  401 mvU=12525  I=   10 mA   15.781 V  0.010 A  0.003 W  Seuil=0.250 A
    2 AFF=0  mvA=  401 mvU=12525  I=   10 mA   15.781 V  0.010 A  0.003 W  Seuil=0.250 A
    3 AFF=0  mvA=  400 mvU=12524  I=   10 mA   15.780 V  0.010 A  0.003 W  Seuil=0.250 A

CONS=0300
Recu :CONS=0300
 Nouvelle Consigne Duty PWM = 00300   <------moteur  l'arret
    4 AFF=0  mvA=  402 mvU=12525  I=   10 mA   15.781 V  0.010 A  0.003 W  Seuil=0.250 A
    5 AFF=0  mvA= 1077 mvU=12504  I=   27 mA   15.755 V  0.027 A  0.007 W  Seuil=0.250 A
    6 AFF=0  mvA= 1064 mvU=12504  I=   27 mA   15.755 V  0.027 A  0.006 W  Seuil=0.250 A

CONS=0400
Recu :CONS=0400
 Nouvelle Consigne Duty PWM = 00400    <------moteur  l'arret
   10 AFF=0  mvA=  965 mvU=12507  I=   25 mA   15.759 V  0.024 A  0.006 W  Seuil=0.250 A
   11 AFF=0  mvA= 1774 mvU=12483  I=   45 mA   15.729 V  0.044 A  0.011 W  Seuil=0.250 A
   12 AFF=0  mvA= 1786 mvU=12483  I=   45 mA   15.729 V  0.045 A  0.011 W  Seuil=0.250 A
....

CONS=0500
Recu :CONS=0500
 Nouvelle Consigne Duty PWM = 00500  <------moteur  l'arret
   19 AFF=0  mvA= 1773 mvU=12483  I=   45 mA   15.729 V  0.044 A  0.011 W  Seuil=0.250 A
   20 AFF=0  mvA= 2567 mvU=12460  I=   65 mA   15.700 V  0.064 A  0.016 W  Seuil=0.250 A
   21 AFF=0  mvA= 2557 mvU=12460  I=   65 mA   15.700 V  0.064 A  0.016 W  Seuil=0.250 A
   22 AFF=0  mvA= 2557 mvU=12460  I=   65 mA   15.700 V  0.064 A  0.016 W  Seuil=0.250 A
  .......
  
CONS=0600
   30 AFF=0  mvA= 2576 mvU=12458  I=   65 mA   15.697 V  0.064 A  0.016 W  Seuil=0.250 ARecu :CONS=0600
 Nouvelle Consigne Duty PWM = 00600  <---- moteur tourne
   31 AFF=0  mvA= 2570 mvU=12457  I=   65 mA   15.696 V  0.064 A  0.016 W  Seuil=0.250 A
   32 AFF=0  mvA= 2979 mvU=12444  I=   76 mA   15.679 V  0.074 A  0.019 W  Seuil=0.250 A
   33 AFF=0  mvA= 2945 mvU=12446  I=   76 mA   15.682 V  0.074 A  0.019 W  Seuil=0.250 A

  657 AFF=0  mvA= 2509 mvU=12428  I=   64 mA   15.659 V  0.063 A  0.016 W  Seuil=0.250 A
  658 AFF=0  mvA= 2478 mvU=12433  I=   63 mA   15.666 V  0.062 A  0.016 W  Seuil=0.250 A
  659 AFF=0  mvA= 2535 mvU=12437  I=   64 mA   15.671 V  0.063 A  0.016 W  Seuil=0.250 A
  660 AFF=0  mvA= 2499 mvU=12437  I=   63 mA   15.671 V  0.062 A  0.016 W  Seuil=0.250 A
S=120
  661 AFF=0  mvA= 2440 mvU=12438  I=   62 mA   15.672 V  0.061 A  0.015 W  Seuil=0.250 ARecu :S=120
seuil k=  4800   Sauve valeur dans  MASK_EN_REG register 07h 
 Relecture  valeur de MASK_EN_REG register 07h 
 NEW Seuil d'alerte 0.120 Amperes

  662 AFF=0  mvA= 2423 mvU=12443  I=   62 mA   15.678 V  0.061 A  0.016 W  Seuil=0.120 A
  663 AFF=0  mvA= 2450 mvU=12446  I=   62 mA   15.682 V  0.061 A  0.016 W  Seuil=0.120 A
  664 AFF=0  mvA= 2412 mvU=12446  I=   61 mA   15.682 V  0.060 A  0.015 W  Seuil=0.120 A
  665 AFF=0  mvA= 2448 mvU=12446  I=   62 mA   15.682 V  0.061 A  0.016 W  Seuil=0.120 A
  666 AFF=0  mvA= 2520 mvU=12448  I=   64 mA   15.684 V  0.063 A  0.016 W  Seuil=0.120 A
  667 AFF=0  mvA= 3924 mvU=12388  I=  100 mA   15.609 V  0.098 A  0.025 W  Seuil=0.120 A*AL
*AL
*AL
*AL

  668 AFF=0  mvA= 3767 mvU=12411  I=   96 mA   15.638 V  0.094 A  0.024 W  Seuil=0.120 A
  669 AFF=0  mvA= 2450 mvU=12447  I=   62 mA   15.683 V  0.061 A  0.016 W  Seuil=0.120 A
  670 AFF=0  mvA= 2445 mvU=12451  I=   62 mA   15.688 V  0.061 A  0.016 W  Seuil=0.120 A
  */